unit v46unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Gauges;

const
       cleft = 4;
       cdown = 5;
       cup   = 7;
       cright = 6;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Image1: TImage;
    ImageList1: TImageList;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Gauge1: TGauge;
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    radek,
    sloupec : byte;
    pole : array[-1..40, -1..20] of byte;
    smer : byte;
    px, py : byte;
    body : word;
    zivoty : byte;
    zradlo : word;
    r : trect;

    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses v46unit2;

{$R *.DFM}


procedure TForm1.FormActivate(Sender: TObject);
var

  i,ii : word;
  s : string;
  Obr : TImage;
  x : byte;

begin
   Gauge1.MaxValue:=0;
  ImageList1.GetBitmap(1, Image3.Picture.Bitmap);
  ImageList1.GetBitmap(15, Image4.Picture.Bitmap);
  ImageList1.GetBitmap(2, Image5.Picture.Bitmap);
  ImageList1.GetBitmap(3, Image6.Picture.Bitmap);

  Randomize;
  Obr:=TImage.Create(self);
  Memo1.Lines.LoadFromFile(Paramstr(1));
  radek:=length(Memo1.Lines.Strings[0]);
  sloupec:=Memo1.Lines.Count;

  for i:=0 to sloupec-1 do
   begin
    s:=memo1.lines.strings[i];
    for ii:=0 to radek-1 do
     begin
          case s[ii+1] of #46:  case random(3) of
                                0:x:=8;
                                1:x:=9;
                                2:x:=10;
                              end;
                        #42:  begin
                                x:=4;
                                Image2.left:=ii*20;
                                Image2.top:=i*20;
                                ImageList1.GetBitmap(cdown, Image2.Picture.Bitmap);
                                smer:=cdown;
                                px:=ii;
                                py:=i;
                                Gauge1.MaxValue:=Gauge1.MaxValue+1;
                              end;
                        #64:  x:=11;
                        #35:  x:=0;
          else x:=255;
          end;
          pole[ii, i]:=x;
          if (x<>255) and (x<>4) then
            begin
              Obr.free;
              Obr:=TImage.Create(self);
              ImageList1.GetBitmap(x, Obr.Picture.Bitmap);
              Image1.Canvas.Draw(ii*20,i*20, Obr.Picture.Bitmap);
            end;
      end;
End;
    End;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

var r : trect;
begin


if key=vk_pause then Form2.ShowModal;



case key of vk_left:Bevel1.Style:=bsLowered;
            vk_down:Bevel3.Style:=bsLowered;
            vk_right:Bevel4.Style:=bsLowered;
            vk_up:Bevel2.Style:=bsLowered;
end;

if ssShift in Shift then
  case key of vk_left: begin
                         if (smer=cleft) and (pX>1) and ((pole[px-1,py])+(pole[px-2,py])= 255+255) then
                           begin
                             pole[px,py]:=255;
                             dec(px,2);
                           end;
                          if smer <> cleft then smer:=cleft;
                       end;

               vk_right: begin
                         if (smer=cright) and (px<radek-1) and ((pole[px+1,py]+pole[px+2,py]= 255+255)) then
                           begin
                             pole[px,py]:=255;
                             inc(px,2);
                           end;
                          if smer <> cright then smer:=cright;
                       end;

               vk_up: begin
                         if (smer=cup) and (py>1) and ((pole[px,py-1]+pole[px,py-2])= 255+255) then
                           begin
                             pole[px,py]:=255;
                             dec(py,2);
                           end;
                          if smer <> cup then smer:=cup;
                       end;

               vk_down: begin
                         if (smer=cdown) and (py<sloupec-1) and ((pole[px,py+1]+pole[px,py+2])= 255+255) then
                           begin
                             pole[px,py]:=255;
                             inc(py,2);
                           end;
                          if smer <> cdown then smer:=cdown;
                       end;
  end
else
  case key of vk_left: begin
                         if (smer=cleft) and (pX>0) and (((pole[px-1,py])= 255) or (pole[px-1, py] in [8..10])) then
                           begin
                             if pole[px-1, py] in [8..10] then
                               begin
                                 inc(body);
                                 dec(zradlo);
                                 Label1.Caption:=InttoStr(body);
                               end;
                             pole[px,py]:=255;
                             dec(px);
                           end;
                          if smer <> cleft then smer:=cleft;
                       end;

               vk_right: begin
                         if (smer=cright) and (px<radek-2) and (((pole[px+1,py])= 255) or (pole[px+1, py] in [8..10])) then
                           begin
                             if pole[px+1, py] in [8..10] then
                               begin
                                 inc(body);
                                 dec(zradlo);
                                 Label1.Caption:=InttoStr(body);
                               end;
                             pole[px,py]:=255;
                             inc(px);
                           end;
                          if smer <> cright then smer:=cright;
                       end;

               vk_up: begin
                         if (smer=cup) and (py>0) and ((pole[px,py-1])= 255) or (pole[px, py-1] in [8..10])then
                           begin
                             if pole[px, py-1] in [8..10] then
                               begin
                                 inc(body);
                                 dec(zradlo);

                                 Label1.Caption:=InttoStr(body);
                               end;
                             pole[px,py]:=255;
                             dec(py);
                           end;
                          if smer <> cup then smer:=cup;
                       end;

               vk_down: begin
                         if (smer=cdown) and (py<sloupec-2) and ((pole[px,py+1])= 255) or (pole[px, py+1] in [8..10])then
                           begin
                             if pole[px, py+1] in [8..10] then
                               begin
                                 inc(body);
                                 dec(zradlo);
                                 Label1.Caption:=InttoStr(body);
                               end;
                             pole[px,py]:=255;
                             inc(py);
                           end;
                          if smer <> cdown then smer:=cdown;
                       end;
end;
  If pole[px, py]  in [8..10] then
    begin
      with r do
        begin
          left:=px*20;
          top:=py*20;
          right:=left+20;
          bottom:=top+20;
        end;
    end;

  Gauge1.Progress:=body;
  Image2.left:=px*20;
  Image2.top:=py*20;

  ImageList1.GetBitmap(smer, Image2.Picture.Bitmap);
  Image2.Refresh;

 case key of vk_left:Bevel1.Style:=bsRaised;
            vk_down:Bevel3.Style:=bsRaised;
            vk_right:Bevel4.Style:=bsRaised;
            vk_up:Bevel2.Style:=bsRaised;
end;

end;

end.
